package net.kazhik.android.tokyorunners;

import java.io.FileOutputStream;
import java.io.IOException;
import java.io.OutputStreamWriter;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;

import android.content.Context;
import android.location.Location;

public class RunningRecord {
	private class Record {
		Date date;
		Location location;
		Record(Date date, Location loc) {
			this.date = date;
			this.location = loc;
		}
	}
	ArrayList<Record> m_record = new ArrayList<Record>();
//	HashMap<Date, Location> m_record = new HashMap<Date, Location>();
	private int m_distance = 0;
	private Location m_prevLocation = null;
	
	public void addRecord(Date date, Location loc) {
		Record newRecord = new Record(date, loc);
		m_record.add(newRecord);
		
		if (m_prevLocation != null) {
			m_distance += (int)m_prevLocation.distanceTo(loc);
		}
		m_prevLocation = loc;
	}
	public float getDistance() {
		return (float)m_distance / 1000;
	}
	
	public void save(OutputStreamWriter stWriter) throws IOException {
		stWriter.write(
			"<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n" +
			"<gpx\n" +
			" version=\"1.0\"\n" +
			"creator=\"Tokyo Runners\"\n" +
			"xmlns:xsi=\"http://www.w3.org/2001/XMLSchema-instance\"\n" +
			"xmlns=\"http://www.topografix.com/GPX/1/0\"\n" +
			"xsi:schemaLocation=\"http://www.topografix.com/GPX/1/0 http://www.topografix.com/GPX/1/0/gpx.xsd\">\"\n");

		stWriter.write(
			"<trk>\n"+
			"<trkseg>\n");
		

	    SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");		
	    SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");		

		for (Iterator<Record> it = m_record.iterator(); it.hasNext();) {
			Record rec = (Record)it.next();
			
			stWriter.write(
				"<trkpt lat=\"" + rec.location.getLatitude()+"\" lon=\"" + rec.location.getLongitude()+"\">\n" +
				"<time>" + dateFormat.format(rec.date.getTime()) + "T" + timeFormat.format(rec.date.getTime())+"Z</time>\n" +
				"<speed>" + "speed" + "</speed>\n"+
				"<name>" + "name" + "</name>\n"+
				"<fix>none</fix>\n"+
				"</trkpt>\n");

		}
		
		stWriter.write(
			"</trkseg>\n"+
			"</trk>\n"+
			"</gpx>\n");
		
		stWriter.flush();
		
		
	}
	public void save(String filename) {
		
		
	}

}
